package com.ddignani;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;

public class ReservationActivity extends Activity{
	public static final int ACTION_DECLINE = 0;
	public static final int ACTION_REFRESH = 1;
	public static final String ACTION = "action";
	
	private Long mRowId;
	ReservationsDbAdapter dbAdapter;
	
	TextView name;
	TextView time;
	TextView message;
	
	AlertDialog alert;
	
	public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
              
        setContentView(R.layout.reservation_detail);
        
        name = (TextView)findViewById(R.id.reservation_detail_name);
        time = (TextView)findViewById(R.id.reservation_detail_time);
        message = (TextView)findViewById(R.id.reservation_detail_message);

        dbAdapter = new ReservationsDbAdapter(this);
        fillData();
    	
    	Button declineBtn = (Button)findViewById(R.id.reservation_detail_decline_btn);
    	Button refreshBtn = (Button)findViewById(R.id.reservation_detail_refresh_btn);
    	
    	//Dialogo di conferma
    	alert = new AlertDialog.Builder(this).create();
    	
    	//Comportamenti dei pulsanti
    	declineBtn.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				alert.setTitle(R.string.decline_reserv);
				alert.setMessage(getResources().getText(R.string.decline_reserv_dialog));
				//Crea il pulsante S
				alert.setButton(DialogInterface.BUTTON_POSITIVE, getResources().getText(R.string.yes), new DialogInterface.OnClickListener() {
					@Override
					public void onClick(DialogInterface dialog, int which) {
		        		Intent intent = new Intent();
		        		intent.putExtra(ACTION, ACTION_DECLINE);
		        		intent.putExtra(ReservationsDbAdapter.KEY_ROWID, mRowId);
						setResult(RESULT_OK, intent);
		        		finish();
					}
				});
				//Crea il pulsante NO
				alert.setButton(DialogInterface.BUTTON_NEGATIVE, getResources().getText(R.string.no), new DialogInterface.OnClickListener() {		
					@Override
					public void onClick(DialogInterface dialog, int which) {
						dialog.dismiss();
					}
				});
				alert.show();	
			}
		});
    	
    	refreshBtn.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				Intent intent = new Intent();
        		intent.putExtra(ACTION, ACTION_REFRESH);
        		intent.putExtra(ReservationsDbAdapter.KEY_ROWID, mRowId);
				setResult(RESULT_OK, intent);
        		finish();
			}
		});
	}

	/**
	 * Recupera la reservation passata nell'intent e riempie i campi di testo
	 */
	private void fillData() {
		Reservation res;
		Bundle extras = getIntent().getExtras();
        mRowId = extras != null ? extras.getLong(ReservationsDbAdapter.KEY_ROWID) : null;

        // La rowId non viene trovata...
        if(mRowId == null || mRowId == -1){
        	setResult(RESULT_CANCELED);
        	finish();
        }   
		
        res = dbAdapter.fetchReservation(mRowId);
        //Imposto i valori ai campi di testo
        name.setText(res.getName());
    	time.setText(res.getReadableServiceTime());
    	message.setText(res.getMsgFromServer());
	}
}
