package com.ddignani;

import android.content.Context;
import android.database.Cursor;
import android.text.format.Time;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.CursorAdapter;
import android.widget.TextView;

public class ReservationCursorAdapter extends CursorAdapter {

	private Context mContext;
	private int mLayout;
	private LayoutInflater mInflater;
	
	public ReservationCursorAdapter (Context context, Cursor cursor, boolean autoRequery) {
		super(context, cursor, autoRequery);	
		mContext = context;
		mInflater = LayoutInflater.from(context);
		mLayout = R.layout.reserv_row;
	}


	@Override
	public void bindView(View view, Context context, Cursor cursor) {
		
		TextView name = (TextView)view.findViewById(R.id.row_name);
		TextView infos = (TextView)view.findViewById(R.id.row_infos);
		TextView time = (TextView)view.findViewById(R.id.row_time);
		TextView lastUpdate = (TextView)view.findViewById(R.id.row_last_update);
		
		name.setText(cursor.getString(cursor.getColumnIndex(ReservationsDbAdapter.KEY_NAME)));
		infos.setText(cursor.getString(cursor.getColumnIndex(ReservationsDbAdapter.KEY_MSG)));
		Time t = new Time();
		t.set(cursor.getLong(cursor.getColumnIndex(ReservationsDbAdapter.KEY_LASTUPDATE)));
		lastUpdate.setText(mContext.getText(R.string.last_update) + " " + t.format("%H:%M"));
		t.set(t.toMillis(false) + cursor.getLong(cursor.getColumnIndex(ReservationsDbAdapter.KEY_WAITING)));
		time.setText(t.format("%H:%M"));
	
	}


	@Override
	public View newView(Context context, Cursor cursor, ViewGroup parent) {		
		return mInflater.inflate(mLayout, parent, false);
		// il framework poi chiama bindView in automatico
	}


}
