package com.ddignani.network;
import java.io.Serializable;


public class ServerResponse implements Serializable {
	private static final long serialVersionUID = 1L;
	
	public static final int READY = 0;
	public static final int ENQUEUED = 1;
	public static final int DEQUEUED = 2;
	public static final int UPDATED = 3;
	public static final int CONFIRMED = 4;
	public static final int ERROR = -1;
	
	private int status;
	private long time;
	private String moreInfo;
	
	public ServerResponse(){
		status = READY;
		time = 0;
	}

	public String toString(){
		return status + " | " + time+ " | " + moreInfo + " |";
	}
	
	public int getStatus() {
		return status;
	}

	public void setStatus(int status) {
		this.status = status;
	}

	public long getTime() {
		return time;
	}

	public void setTime(long time) {
		this.time = time;
	}

	public String getMoreInfo() {
		return moreInfo;
	}

	public void setMoreInfo(String moreInfo) {
		this.moreInfo = moreInfo;
	}
}
