import java.io.IOException;
import java.util.Random;

public class QueueServer extends Thread {

	static final int SECONDS = 1000;
	static final int MINUTES = 60 * SECONDS;
	
	static final int KIQ_SERVER_PORT = 8888;	//Porta di ascolto del server KIQ
	
	static final int MINSERVICE = 30;			//Durata minima del servizio chiesto dal cliente
	static final int MAXSERVICE = 50;			//Durata massimo del servizio chiesto dal cliente
	static final int DELAY = 40;				//Intervallo di arrivo tra i customer
	static final int T_UNIT = SECONDS;			//SECOND o MINUTES
	static final int PATIENT_QUOTE = 0;		//Probabilit di Customer "pazienti" in %
	
	static private QueueMonitor queue;
	
	
	public static void main(String[] args) throws IOException, InterruptedException {

		queue = new QueueMonitor();
		Operator operator = new Operator(queue);
		Customer customer;
		
		int i = 0;
		int minService, maxService, delay, t_unit;
		if(args.length == 4){
			minService = Integer.parseInt(args[0]);
			maxService = Integer.parseInt(args[1]);
			delay = Integer.parseInt(args[2]);
			if(args[3].compareToIgnoreCase("m") == 0)
				t_unit = MINUTES;
			else if(args[3].compareToIgnoreCase("s") == 0)
				t_unit = SECONDS;
			else
				t_unit = SECONDS;
		}else{
			minService = MINSERVICE;
			maxService = MAXSERVICE;
			delay = DELAY;
			t_unit = T_UNIT;
		}
		
		String u = (t_unit == MINUTES )? "m":"s";
		System.out.println("TIP: e' possibile specificare (tutti!) TMIN TMAX DELAY TIMEUNIT(m|s)");
		System.out.print("\n\n*** Simulazione con Tmin: " + minService + u + ", Tmax: " + maxService + u + ", Delay: " + delay + u);
		if(args.length != 4)
			System.out.println(" (valori di default) ***");
		else
			System.out.println(" ***");
		
		// avvia l'operatore
		operator.start();
		
		//Avvia il server per i clienti con KeepInQ
		KeepInQServer keepInQServer = new KeepInQServer(KIQ_SERVER_PORT, queue, operator);
		keepInQServer.start();
		sleep(100); //solo per far comparire prima la scritta del server attivo e poi la tabella...
		
		System.out.println("-----------------------------------------------------------------------------");
		System.out.println("Evento:\t\t\t\t\tDurata\t#prima\tAttesa\tAttesa_Max  |");
		System.out.println("-----------------------------------------------------------------------------");
		
		
		
		
		
		//Simula l'arrivo di altri clienti
		while(true){
			long serviceTime = (new Random().nextInt(maxService - minService) + minService) * t_unit;
			boolean isPatient = (new Random().nextInt(100) >  PATIENT_QUOTE);
			customer = new Customer(queue, "Customer " + ((i>9)?i:" "+i), serviceTime, isPatient);
			customer.start();
			queue.insertInQueue(customer);
			i++;
			if(i > 7)
				sleep(DELAY * T_UNIT);
		}	
	} 
}
